<template>
  <div>
    <span class="q-mt-xl page-header"> {{ t('changePassHeader') }} </span>
    <p class="page-subtitle">{{ t('changePassSubtitle') }}</p>

    <q-form class="column q-mt-xl" @submit="
        {
    }
      ">

      <q-input v-model="usernameInput" class="q-mb-md" :label="t('usernameInputLabel')"
        :rules="[(val) => val.length > 0 || t('usernameInputEmptyRule')]">
        <template #prepend>
          <q-icon name="person_outline" />
        </template>
      </q-input>
      <q-input v-model="oldPasswordInput" class="q-mb-md" :label="t('oldPasswordInputLabel')"
        :type="isVisible ? 'text' : 'password'" :rules="[(val) => val.length > 0 || t('oldPasswordInputEmptyRule')]">
        <template #prepend>
          <q-icon name="lock_outline" />
        </template>

        <template #append>
          <q-icon :name="isVisible ? 'visibility_off' : 'visibility'" class="cursor-pointer"
            @click="isVisible = !isVisible" />
        </template>
      </q-input>
      <q-input v-model="passwordInput" :label="t('newPasswordInputLabel')" :type="isVisible ? 'text' : 'password'"
        :rules="[(val) => val.length > 0 || t('passwordInputEmptyRule')]">
        <template #prepend>
          <q-icon name="lock_outline" />
        </template>

        <template #append>
          <q-icon :name="isVisible ? 'visibility_off' : 'visibility'" class="cursor-pointer"
            @click="isVisible = !isVisible" />
        </template>
      </q-input>

      <q-btn rounded class="q-mt-md" padding="md" type="submit" :loading="isLoading" :disable="isLoading"
        @click="handleChangePassword">
        {{ t('changePassLabel') }}
      </q-btn>
    </q-form>

    <q-space></q-space>


  </div>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { useI18n } from 'vue-i18n';
import { useAuth } from '../hooks/auth';
import { useRouter } from 'vue-router';

const { t } = useI18n();
const { isLoading, error, changePassword } = useAuth();

const router = useRouter();
const passwordInput = ref<string>('');
const oldPasswordInput = ref<string>('');
const usernameInput = ref<string>('');
const isVisible = ref<boolean>(false);

const handleChangePassword = async () => {
  if (!usernameInput.value || !passwordInput.value || !oldPasswordInput.value) {
    return;
  }
  await changePassword({
    password: oldPasswordInput.value,
    username: usernameInput.value,
    new_password: passwordInput.value,
  });
  if (!error.value) {
    router.push('/');
  }
};
</script>